## docker.io-app 20.10.25

=== debian/changelog ===
docker.io-app (20.10.25-0ubuntu1~22.10.1) kinetic; urgency=medium

  * Backport version from Mantic to Kinetic (LP: #2023694, #2022390)

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 29 Jun 2023 18:21:05 -0300

docker.io-app (20.10.25-0ubuntu1) mantic; urgency=medium

  * Initial release. See LP #2022390.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 17 May 2023 16:17:52 -0300
