=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                dh-exec,
                dh-golang,
                git,
-               golang-go,
+               golang-1.20-go,
                libapparmor-dev,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libdevmapper-dev (>= 2:1.02.68~),
@@ -28,7 +28,7 @@
 Vcs-Browser: https://github.com/canonical/docker.io-app
 
 Package: docker.io
-Architecture: amd64 arm64 armhf i386 ppc64el riscv64 s390x
+Architecture: any
 Depends: adduser,
          containerd (>= 1.2.6-0ubuntu1~),
          iptables,
