=== vendor/github.com/moby/buildkit/util/archutil/Makefile ===
generate:
	DOCKER_BUILDKIT=1 docker build -o . .

.PHONY: generate
