=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                dh-exec,
                dh-golang,
                git,
-               golang-1.20-go,
+               golang-1.22-go,
                libapparmor-dev,
                libbtrfs-dev | btrfs-progs (<< 4.16.1~),
                libdevmapper-dev (>= 2:1.02.68~),
@@ -44,6 +44,8 @@
           btrfs-progs,
           cgroupfs-mount | cgroup-lite,
           debootstrap,
+          docker-buildx,
+          docker-compose-v2,
           docker-doc,
           rinse,
           zfs-fuse | zfsutils
